function render(_role, _roles){

    if(_role in _roles) {
        renderRole(_roles[_role], _roles["idle"]);
        return;
    }

    if(_role === "idle") {
        //We have no role definitions yet, but the role is default idle
        $("#game_content").html("Please wait for the game to start.");
        return;
    }

    //This is not good
    set_error("The role of this player has no render target.");
}

function renderRole(_definition, _roleIdle) {

    if(_roleIdle && (_definition !== _roleIdle)){
        var old_css_idle = $("#game_css_idle");

        if(old_css_idle) {
            old_css_idle.remove();
        }

        if("css" in _roleIdle) {
            //Add idle css
            var css = $("<style id='game_css_idle' type='text/css'>" + sanitizeCSS(_roleIdle["css"]) + "</style>");
            $("#current_content").append(css);
        }
    }

    var old_css = $("#game_css");

    if(old_css) {
        old_css.remove();
    }

    if("css" in _definition) {
        //Add additional css
        var css = $("<style id='game_css' type='text/css'>" + sanitizeCSS(_definition["css"]) + "</style>");
        $("#current_content").append(css);
    }

    var elements = _definition["elements"];

    $("#game_content").html("");

    var prompt = prompts[currentPrompt];

    for(var index in elements) {

        var element = elements[index];

        var type = element["type"];
        var c = element["class"];
        var name = element["name"];
        var value = element["value"];

        if(prompt){
            for(var varname in prompt){
                while(value.indexOf("$"+varname) != -1){
                    value = value.replace("$"+varname, prompt[varname]);
                }
            }
        }

        var e;
        switch(type) {
            case "text":
                e = $("<span></span>");
                e.html(value);
                break;
            case "input":
                e = $("<input type='text'/>");
                e.attr("placeholder", value);
                break;
            case "submit":
                e = $("<input type='submit'/>");
                e.val(value);
                break;
            default:
                e = $("<span>Invalid Element</span>");
                break;
        }
        e.attr("name", name);
        e.addClass(c);

        var p = $("<p></p>").append(e);
        $("#game_content").append(p);
    }
}

function sanitizeCSS(_css) {
    return(_css.replace(/</g, ""))
}
